#pragma once

#include "voxel_painter.hpp"
#include "projection.hpp"

namespace BGTU::ComputerGraphicsLabWork::RendererApi {
	class SpriteMetadata {
	public:
		virtual void clicked() {};
	};

	template<class _data_t, class _voxel_painter_t = VirtualVoxelPainter>
	class Sprite : public SpriteMetadata {
	public:
		using data_t = _data_t;
		using voxel_painter_t = _voxel_painter_t;


		virtual void draw(_voxel_painter_t *frame, _data_t const *data) const = 0;

		class SpriteDataProvider {
		public:
			virtual _data_t get_sprite_data() = 0;
		};
	};
}