#include "frame.hpp"
#include "shaders.hpp"

COLOR BarycentricInterpolator::get_color(int x, int y) const {
// Барицентрическая интерполяция
    float h0 = ((y1 - y2) * (x - x2) + (x2 - x1) * (y - y2)) / S;
    float h1 = ((y2 - y0) * (x - x2) + (x0 - x2) * (y - y2)) / S;
    float h2 = 1 - h0 - h1;
    float r = h0 * C0.red + h1 * C1.red + h2 * C2.red;
    float g = h0 * C0.green + h1 * C1.green + h2 * C2.green;
    float b = h0 * C0.blue + h1 * C1.blue + h2 * C2.blue;
    float a = h0 * C0.alpha + h1 * C1.alpha + h2 * C2.alpha;
    return COLOR(r, g, b, a);
}


COLOR RadialBrush::get_color(int x, int y) const {
    double dx = (double) x - cx, dy = (double) y - cy;
    double radius = sqrt(dx * dx + dy * dy);
    float h0 = (sin(radius / 10 + angle) + 1.0f) / 2;
    float h1 = 1 - h0;
    float r = h0 * C0.red + h1 * C1.red;
    float g = h0 * C0.green + h1 * C1.green;
    float b = h0 * C0.blue + h1 * C1.blue;
    return COLOR(r, g, b);
}